#include "gui/status_ui.hpp"
#include "components.hpp"
#include <guecs/ui.hpp>
#include "rand.hpp"
#include <fmt/xchar.h>
#include "gui/guecstra.hpp"
#include "systems.hpp"
#include "inventory.hpp"
#include "game_level.hpp"

namespace gui {
  using namespace guecs;
  using std::any, std::any_cast, std::string, std::make_any;

  StatusUI::StatusUI()
  {
    $gui.position(STATUS_UI_X, STATUS_UI_Y, STATUS_UI_WIDTH, STATUS_UI_HEIGHT);
    $gui.layout(
        "[ritual_ui]"
        "[=earring|=armor_head|=amulet]"
        "[=back|=*%(200,300)character_view|_|=armor_bdy]"
        "[=hand_r|_|_                        |=hand_l]"
        "[=ring_r|_|_                        |=ring_l]"
        "[=pocket_r|=armor_leg|=pocket_l]");
  }

  void StatusUI::init() {
    $gui.set<Background>($gui.MAIN, {$gui.$parser, });

    for(auto& [name, cell] : $gui.cells()) {
      auto gui_id = $gui.entity(name);

      if(name == "character_view") {
        $gui.set<Rectangle>(gui_id, {});
        $gui.set<Sprite>(gui_id, {"peasant_girl"});
      } else {
        $gui.set<Rectangle>(gui_id, {});

        if(name == "ritual_ui") {
          $gui.set<Clickable>(gui_id, {
              [this](auto){ select_ritual(); }
          });
          $gui.set<Sound>(gui_id, {"pickup"});
        } else {
          $gui.set<Text>(gui_id, {guecs::to_wstring(name)});
          $gui.set<Clickable>(gui_id, {
            guecs::make_action(gui_id, Events::GUI::INV_SELECT, {gui_id})
          });
          $gui.set<DropTarget>(gui_id, {
              .commit=[&, gui_id](DinkyECS::Entity world_target) -> bool {
                return place_slot(gui_id, world_target);
              }
          });
        }
      }
    }

    $ritual_ui.event(ritual::Event::STARTED);
    $gui.init();
    update();
  }

  bool StatusUI::mouse(float x, float y, guecs::Modifiers mods) {
    if($ritual_ui.is_open()) {
      return $ritual_ui.mouse(x, y, mods);
    } else {
      return $gui.mouse(x, y, mods);
    }
  }

  void StatusUI::select_ritual() {
    $ritual_ui.event(ritual::Event::TOGGLE);
  }

  void StatusUI::update() {
    auto world = GameDB::current_world();
    auto player = world->get_the<components::Player>();
    auto& inventory = world->get<inventory::Model>(player.entity);

    for(const auto& [slot, cell] : $gui.cells()) {

      if(inventory.has(slot)) {
        auto gui_id = $gui.entity(slot);
        auto world_entity = inventory.get(slot);

        auto& sprite = world->get<components::Sprite>(world_entity);
        $gui.set_init<guecs::Icon>(gui_id, {sprite.name});
        guecs::GrabSource grabber{ world_entity,
            [&, gui_id]() { return remove_slot(gui_id); }};
        grabber.setSprite($gui, gui_id);
        $gui.set<guecs::GrabSource>(gui_id, grabber);
      } else {
        auto gui_id = $gui.entity(slot);

        if($gui.has<guecs::GrabSource>(gui_id)) {
          $gui.remove<guecs::GrabSource>(gui_id);
          $gui.remove<guecs::Icon>(gui_id);
        }
      }
    }
  }

  void StatusUI::render(sf::RenderWindow &window) {
    $gui.render(window);
    // $gui.debug_layout(window);
    $ritual_ui.render(window);
  }

  void StatusUI::update_level() {
    init();
  }

  bool StatusUI::place_slot(guecs::Entity gui_id, DinkyECS::Entity world_entity) {
    auto& level = GameDB::current_level();
    auto& slot_name = $gui.name_for(gui_id);
    auto& inventory = level.world->get<inventory::Model>(level.player);

    if(inventory.add(slot_name, world_entity)) {
      level.world->make_constant(world_entity);
      update();
      return true;
    }  else {
      dbc::log("there's something there already");
      return false;
    }
  }

  void StatusUI::drop_item(DinkyECS::Entity item_id) {
    System::drop_item(item_id);
    update();
  }

  // NOTE: do I need this or how does it relate to drop_item?
  void StatusUI::remove_slot(guecs::Entity slot_id) {
    auto player = GameDB::the_player();
    auto& slot_name = $gui.name_for(slot_id);
    System::remove_from_container(player, slot_name);
    update();
  }

  void StatusUI::swap(guecs::Entity gui_a, guecs::Entity gui_b) {
    if(gui_a != gui_b) {
      auto player = GameDB::the_player();
      auto& a_name = $gui.name_for(gui_a);
      auto& b_name = $gui.name_for(gui_b);
      System::inventory_swap(player, a_name, b_name);
    }

    update();
  }

  bool StatusUI::occupied(guecs::Entity slot) {
    auto player = GameDB::the_player();
    return System::inventory_occupied(player, $gui.name_for(slot));
  }
}
